proc Scroll_Set {scrollbar geoCmd offset size} {

  if {$offset != 0.0 || $size != 1.0} {
    eval $geoCmd                     ;# Make sure it is visible
    $scrollbar set $offset $size
  } else {
    set manager [lindex $geoCmd 0]
    $manager forget $scrollbar       ;# hide it
  }
}

proc Scrolled_Listbox { f args } {

  frame $f
  listbox $f.list \
    -xscrollcommand [list Scroll_Set $f.xscroll \
      [list grid $f.xscroll -row 1 -column 0 -sticky we]] \
    -yscrollcommand [list Scroll_Set $f.yscroll \
      [list grid $f.yscroll -row 0 -column 1 -sticky ns]]

  eval {$f.list configure} $args
  scrollbar $f.xscroll -orient horizontal \
    -command [list $f.list xview]
  scrollbar $f.yscroll -orient vertical \
    -command [list $f.list yview]

  grid $f.list $f.yscroll -sticky news
  grid $f.xscroll -sticky news
  grid rowconfigure $f 0 -weight 1
  grid columnconfigure $f 0 -weight 1
  return $f.list
}
